#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define NSNPS 4
#define NSAMPLES 83 
#define BUFFSIZE 6300

int iter;
int flag;

#define REF 0
#define VAR 1

#define DEBUG 0

void simpheno(int *G, int ng, double *P, double epsilon);
double normdraw(void);

int main(int argc, char **argv)  {


  FILE *fp, *fq; 

  const char *fgeno = "./tiny.geno";
  const char *fpheno = "./tiny.qpheno";
  char fname[100];
  char buff[BUFFSIZE];
  int G[BUFFSIZE];
  double P[BUFFSIZE];
  double epsilon;

  int i, j, k;
  int count = 0;

  if ( argc < 2 )  {
    printf ("*** error:  usage simqphenos <epsilon> ***\n");
    exit(1);
  }
  epsilon = atof(argv[1]);
  k = 100*epsilon; 

  if ( (fp = fopen(fgeno,"r")) == NULL )  {
    printf("*** error:  can't open %s ***\n", fgeno);
    exit(1);
  }
  sprintf(fname, "%s.%d", fpheno, k); 
  fq = fopen(fname,"w");

  printf ("Epsilon = %f, outputname = %s\n", epsilon, fname);

  srand(time(NULL));
  for(j=0;j<NSNPS;j++)  {          

    int k;
    fgets(buff, BUFFSIZE, fp); 
    for(k=0;k<NSAMPLES;k++)  {
      G[k] = (int) (buff[k] - '0');
    }

    iter = j;
    simpheno(G, NSAMPLES, P, epsilon);

    for(k=0;k<NSAMPLES;k++)  {
      fprintf(fq, "%.4f ", P[k]);
    }
    fprintf(fq, "\n");

  }

  fclose(fp);
  fclose(fq);

}

void simpheno(int *G, int ng, double *P, double epsilon)  {
  int i; 
  for(i=0;i<ng;i++)  {
    P[i] = G[i]*epsilon + normdraw();
  }
} 

double normdraw(void)  {
  while ( 1 )  {
    double r = (double) rand()/RAND_MAX;
    double s = (double) rand()/RAND_MAX;

    double t = 10.0*( 2*r - 1 );
    if ( exp(-t*t/2.0) >= s )  {
      return t;
    }
  }
}


