#ifndef _IOHANDLER_
#define _IOHANDLER_

#include <fstream>
#include <sstream>
#include <iomanip>
#include <map>
#include <string>
#include <stdlib.h>

#include "Exception.h"

using namespace std;
class IOHandler  {

  public:

    // constructor
    IOHandler()  {  }

    // parse parameter file 
    int readParams(char *filename);

    // parse parameter file - only look for parameter "useempiricalvariance"
    bool previewParams(char *filename);

    // read integer-valued, no-white-space input line
    int readIntLine(ifstream *f, int ndata, int **data);

    // read real-valued, white-space-separated input line
    int readRealLine(ifstream *f, int ndata, double **data);

    // read real-valued, single-column input file
    int readOneColumnFile(string filename, int ndata, double **data);

    // parameter map accessors
    void setParam(string name, string val);

    // NOTE:  make this private when all IO is rewritten
    int getParam(string name, string *val);

    int getPositiveIntParam(string name);
    string getStringParam(string name);
    bool getBoolParam(string name);    

    // open files safely
    void openInput(string param, ifstream *s);
    void openOutput(string param, ofstream *s);

    // DEBUGGING
    void dbgShowParams(void);


  private:
    map<string, string> paramMap;


};




#endif

