#ifndef _SCOREQSUM_
#define _SCOREQSUM_

#include <iostream>
#include <fstream>
#include <string>

#include "IOHandler.h"
#include "Exception.h"

#include "ScoreS2Q.h"
#include "ScoreA2Q.h"

using namespace std;

class ScoreQSUM  {

  public:

    // constructor
    ScoreQSUM(char *paramfile);

    // destructor
    ~ScoreQSUM(void);

    // main loop
    int evaluate(void);

  private:

    int nsamples;
    int nsnps;
   
    ifstream genoStream;
    ifstream phenoStream;
    ifstream localAncStream;
    ofstream outputStream;

    int *dipGenoVec;
    double *dipPhenoVec;
    int *dipLocalAnc;

    double *genoDosages;
    bool geno_is_dosage;
    bool use_adjustment;

    string genoform;

    double *globalAnc;

    IOHandler ioh;

};


#endif
