#ifndef _SCORES1SQ_
#define _SCORES1SQ_

#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>

#include "IOHandler.h"
#include "Exception.h"

using namespace std;

class ScoreS1SQ  {

  public:

    // constructor
    ScoreS1SQ(char *paramfile);

    // destructor
    ~ScoreS1SQ(void);

    // main loop
    int evaluate(void);

  private:
 
    int nsamples;
    int nsnps;

    ifstream genoStream;
    ifstream phenoStream;
    ifstream localAncStream;
    ofstream outputStream;

    int *dipGenoVec;
    double *dipPhenoVec;
    int *dipLocalAnc;      // Note:  score requires integer local ancestry

    IOHandler ioh;

    double evalS1SQ(void);

};

#endif
